Index: XIOS/dev/dev_olga/src/node/axis.cpp
===================================================================
--- XIOS/dev/dev_olga/src/node/axis.cpp	(revision 1077)
+++ XIOS/dev/dev_olga/src/node/axis.cpp	(revision 1099)
@@ -27,5 +27,5 @@
       , isDistributed_(false), hasBounds_(false), isCompressible_(false)
       , numberWrittenIndexes_(0), totalNumberWrittenIndexes_(0), offsetWrittenIndexes_(0)
-      , transformationMap_(), hasValue(false)
+      , transformationMap_(), hasValue(false), doZoomByIndex_(false)
    {
    }
@@ -37,5 +37,5 @@
       , isDistributed_(false), hasBounds_(false), isCompressible_(false)
       , numberWrittenIndexes_(0), totalNumberWrittenIndexes_(0), offsetWrittenIndexes_(0)
-      , transformationMap_(), hasValue(false)
+      , transformationMap_(), hasValue(false), doZoomByIndex_(false)
    {
    }
@@ -334,4 +334,6 @@
        zoom_index.setValue(index.getValue());
      }
+     if (zoom_n.isEmpty()) zoom_n.setValue(n);
+     if (zoom_begin.isEmpty()) zoom_begin.setValue(begin);
    }
 
@@ -384,8 +386,8 @@
         switch(event.type)
         {
-           // case EVENT_ID_SERVER_ATTRIBUT :
-           //   recvServerAttribut(event);
-           //   return true;
-           //   break;
+           case EVENT_ID_DISTRIBUTION_ATTRIBUTE :
+             recvDistributionAttribute(event);
+             return true;
+             break;
           //  case EVENT_ID_INDEX:
           //   recvIndex(event);
@@ -440,15 +442,19 @@
 
      if (this->isChecked) return;
-     if (context->hasClient) sendAttributes();    
+     if (context->hasClient) sendAttributes(globalDim, orderPositionInGrid, distType);    
 
      this->isChecked = true;
    }
 
-  void CAxis::sendAttributes()
+  void CAxis::sendAttributes(const std::vector<int>& globalDim, int orderPositionInGrid,
+                             CServerDistributionDescription::ServerDistributionType distType)
   {
      if (index.numElements() == n_glo.getValue())
        sendNonDistributedAttributes();
      else
+     {
        sendDistributedAttributes();
+       sendDistributionAttribute(globalDim, orderPositionInGrid, distType);
+     }
   }
 
@@ -457,4 +463,5 @@
   {
     CContext* context = CContext::getCurrent();
+
     // int nbSrvPools = (context->hasServer) ? context->clientPrimServer.size() : 1;
     int nbSrvPools = (context->hasServer) ? (context->hasClient ? context->clientPrimServer.size() : 1) : 1;
@@ -466,45 +473,70 @@
       int rank = client->clientRank;
 
-      // size_t ni = this->n.getValue();
-      // size_t ibegin = this->begin.getValue();
-      // size_t zoom_end = global_zoom_begin+global_zoom_n-1;
-      // size_t nZoomCount = 0;
+      size_t ni = this->n.getValue();
+      size_t ibegin = this->begin.getValue();
+      size_t global_zoom_end = global_zoom_begin+global_zoom_n-1;
+      size_t nZoomCount = 0;
       size_t nbIndex = index.numElements();
-      for (size_t idx = 0; idx < nbIndex; ++idx)
-      {
-        globalLocalIndexMap_[index(idx)] = idx;
-        // size_t globalIndex = index(idx);
-        // if (globalIndex >= global_zoom_begin && globalIndex <= zoom_end) ++nZoomCount;
-      }
-
-      // CArray<size_t,1> globalIndexAxis(nbIndex);
-      // std::vector<size_t> globalAxisZoom(nZoomCount);
-      // nZoomCount = 0;
-      // for (size_t idx = 0; idx < nbIndex; ++idx)
-      // {
-      //   size_t globalIndex = index(idx);
-      //   globalIndexAxis(idx) = globalIndex;
-      //   if (globalIndex >= global_zoom_begin && globalIndex <= zoom_end)
-      //   {
-      //     globalAxisZoom[nZoomCount] = globalIndex;
-      //     ++nZoomCount;
-      //   }
-      // }
-
-      // std::set<int> writtenInd;
-      // if (isCompressible_)
-      // {
-      //   for (int idx = 0; idx < data_index.numElements(); ++idx)
-      //   {
-      //     int ind = CDistributionClient::getAxisIndex(data_index(idx), data_begin, ni);
-
-      //     if (ind >= 0 && ind < ni && mask(ind))
-      //     {
-      //       ind += ibegin;
-      //       if (ind >= global_zoom_begin && ind <= zoom_end)
-      //         writtenInd.insert(ind);
-      //     }
-      //   }
-      // }
+
+      if (doZoomByIndex_) 
+      {
+        nZoomCount = zoom_index.numElements();
+      }
+      else
+      {
+        for (size_t idx = 0; idx < nbIndex; ++idx)
+        {
+          globalLocalIndexMap_[index(idx)] = idx;
+          size_t globalIndex = index(idx);
+          if (globalIndex >= global_zoom_begin && globalIndex <= global_zoom_end) ++nZoomCount;
+        }
+      }
+
+
+      CArray<size_t,1> globalIndexAxis(nbIndex);
+      std::vector<size_t> globalAxisZoom(nZoomCount);
+      nZoomCount = 0;
+      if (doZoomByIndex_) 
+      {
+        int nbIndexZoom = zoom_index.numElements();        
+        for (int i = 0; i < nbIndexZoom; ++i)
+        {   
+          globalIndexAxis(i) = zoom_index(i);
+        }
+      }
+      else 
+      {
+        for (size_t idx = 0; idx < nbIndex; ++idx)
+        {
+          size_t globalIndex = index(idx);
+          globalIndexAxis(idx) = globalIndex;
+          if (globalIndex >= global_zoom_begin && globalIndex <= global_zoom_end)
+          {
+            globalAxisZoom[nZoomCount] = globalIndex;
+            ++nZoomCount;
+          }
+        }
+
+        int end       = begin + n -1;        
+        zoom_begin    = global_zoom_begin > begin ? global_zoom_begin : begin;
+        int zoom_end  = global_zoom_end < end ? zoom_end : end;
+        zoom_n        = zoom_end-zoom_begin+1;
+      }
+
+      std::set<int> writtenInd;
+      if (isCompressible_)
+      {
+        for (int idx = 0; idx < data_index.numElements(); ++idx)
+        {
+          int ind = CDistributionClient::getAxisIndex(data_index(idx), data_begin, ni);
+
+          if (ind >= 0 && ind < ni && mask(ind))
+          {
+            ind += ibegin;
+            if (ind >= global_zoom_begin && ind <= global_zoom_end)
+              writtenInd.insert(ind);
+          }
+        }
+      }
 
       CServerDistributionDescription serverDescriptionGlobal(globalDim, nbServer, distType);
@@ -608,4 +640,55 @@
   }
 
+
+  void CAxis::sendDistributionAttribute(const std::vector<int>& globalDim, int orderPositionInGrid,
+                                        CServerDistributionDescription::ServerDistributionType distType)
+  {
+    CContext* context = CContext::getCurrent();
+
+    int nbSrvPools = (context->hasServer) ? (context->hasClient ? context->clientPrimServer.size() : 0) : 1;
+    for (int i = 0; i < nbSrvPools; ++i)
+    {
+      CContextClient* contextClientTmp = (context->hasServer) ? context->clientPrimServer[i]
+                                                                         : context->client;
+      int nbServer = contextClientTmp->serverSize;
+
+      CServerDistributionDescription serverDescription(globalDim, nbServer);
+      serverDescription.computeServerDistribution();
+
+      std::vector<std::vector<int> > serverIndexBegin = serverDescription.getServerIndexBegin();
+      std::vector<std::vector<int> > serverDimensionSizes = serverDescription.getServerDimensionSizes();
+
+      globalDimGrid.resize(globalDim.size());
+      for (int idx = 0; idx < globalDim.size(); ++idx) globalDimGrid(idx) = globalDim[idx];
+
+      CEventClient event(getType(),EVENT_ID_DISTRIBUTION_ATTRIBUTE);
+      if (contextClientTmp->isServerLeader())
+      {
+        std::list<CMessage> msgs;
+
+        const std::list<int>& ranks = contextClientTmp->getRanksServerLeader();
+        for (std::list<int>::const_iterator itRank = ranks.begin(), itRankEnd = ranks.end(); itRank != itRankEnd; ++itRank)
+        {
+          // Use const int to ensure CMessage holds a copy of the value instead of just a reference
+          const int begin = serverIndexBegin[*itRank][orderPositionInGrid];
+          const int ni    = serverDimensionSizes[*itRank][orderPositionInGrid];
+          const int end   = begin + ni - 1;
+
+          msgs.push_back(CMessage());
+          CMessage& msg = msgs.back();
+          msg << this->getId();
+          msg << ni << begin << end;
+          msg << global_zoom_begin.getValue() << global_zoom_n.getValue();
+          msg << isCompressible_;
+          msg << orderPositionInGrid;
+          msg << globalDimGrid;
+
+          event.push(*itRank,1,msg);
+        }
+        contextClientTmp->sendEvent(event);
+      }
+      else contextClientTmp->sendEvent(event);
+    }
+  }
 
   // void CAxis::computeConnectedServer(const std::vector<int>& globalDim, int orderPositionInGrid,
@@ -753,4 +836,5 @@
   {
     CContext* context = CContext::getCurrent();
+
     // int nbSrvPools = (context->hasServer) ? context->clientPrimServer.size() : 1;
     int nbSrvPools = (context->hasServer) ? (context->hasClient ? context->clientPrimServer.size() : 1) : 1;
@@ -859,4 +943,5 @@
     int ns, n, i, j, ind, nv, idx;
     CContext* context = CContext::getCurrent();
+
     //int nbSrvPools = (context->hasServer) ? context->clientPrimServer.size() : 1;
     int nbSrvPools = (context->hasServer) ? (context->hasClient ? context->clientPrimServer.size() : 1) : 1;
@@ -894,8 +979,9 @@
 
         list_indi.push_back(CArray<int,1>(nbData));
-        list_dataInd.push_back(CArray<int,1>(nbData));
-        list_zoomInd.push_back(CArray<int,1>(nbData));
+        list_dataInd.push_back(CArray<int,1>(nbData));        
         list_mask.push_back(CArray<bool,1>(nbData));
 
+        if (doZoomByIndex_)
+          list_zoomInd.push_back(CArray<int,1>(nbData));
 
         if (hasValue)
@@ -908,6 +994,5 @@
 
         CArray<int,1>& indi = list_indi.back();
-        CArray<int,1>& dataIndi = list_dataInd.back();
-        CArray<int,1>& zoomIndi = list_zoomInd.back();
+        CArray<int,1>& dataIndi = list_dataInd.back();        
         CArray<bool,1>& maskIndi = list_mask.back();
 
@@ -920,5 +1005,10 @@
           dataIndi(n) = dataIndex(ind);
           maskIndi(n) = mask(ind);
-          zoomIndi(n) = zoom_index(ind);
+
+          if (doZoomByIndex_)
+          {
+            CArray<int,1>& zoomIndi = list_zoomInd.back();
+            zoomIndi(n) = zoom_index(ind);
+          }
 
           if (hasValue)
@@ -938,8 +1028,14 @@
         listData.push_back(CMessage());
         listData.back() << this->getId()
-                        << list_indi.back() << list_dataInd.back() << list_zoomInd.back() << list_mask.back()
-                        << hasValue;
+                        << list_indi.back() << list_dataInd.back() << list_mask.back();
+
+        listData.back() << doZoomByIndex_;           
+        if (doZoomByIndex_)
+          listData.back() << list_zoomInd.back();
+
+        listData.back() << hasValue;
         if (hasValue)
           listData.back() << list_val.back();
+
         listData.back() << hasBounds_;
         if (hasBounds_)
@@ -982,11 +1078,15 @@
       CBufferIn& buffer = *buffers[idx];
       buffer >> vec_indi[idx];
-      buffer >> vec_dataInd[idx];
-      buffer >> vec_zoomInd[idx];
+      buffer >> vec_dataInd[idx];      
       buffer >> vec_mask[idx];
+
+      buffer >> doZoomByIndex_;
+      if (doZoomByIndex_)
+        buffer >> vec_zoomInd[idx];
 
       buffer >> hasValue;
       if (hasValue)
         buffer >> vec_val[idx];
+
       buffer >> hasBounds_;
       if (hasBounds_)
@@ -1050,133 +1150,77 @@
     }
 
-    int nbZoomIndex = 0;
-    for (int idx = 0; idx < nbReceived; ++idx)
-    {
-      nbZoomIndex += vec_zoomInd[idx].numElements();
-    }
-
-    zoom_index.resize(nbZoomIndex);
-    nbZoomIndex = 0;
-    CArray<int,1>& zoom_Index_Tmp = this->zoom_index;
-    for (int idx = 0; idx < nbReceived; ++idx)
-    {      
-      CArray<int,1> tmp = zoom_Index_Tmp(Range(nbZoomIndex, nbZoomIndex + vec_zoomInd[idx].numElements()-1));
-      tmp = vec_zoomInd[idx];
-
-      nbZoomIndex += vec_zoomInd[idx].numElements();
-    }
-
-
-    {
-      CContextServer* server = CContext::getCurrent()->server;
-      count_write_index_ = zoom_index.numElements();      
-      MPI_Scan(&count_write_index_, &start_write_index_, 1, MPI_INT, MPI_SUM, server->intraComm);
-      global_write_size_ = start_write_index_;
-      start_write_index_ -= count_write_index_;
-      local_write_size_ = count_write_index_;      
-    }
-  }
-
-  // void CAxis::sendServerAttribut(const std::vector<int>& globalDim, int orderPositionInGrid,
-  //                                CServerDistributionDescription::ServerDistributionType distType)
-  // {
-  //   CContext* context = CContext::getCurrent();
-
-  //   CContextClient* contextClientTmp = (0 != context->clientPrimServer) ? context->clientPrimServer 
-  //                                                                       : context->client;
-
-    
-  //   int nbServer = contextClientTmp->serverSize;
-
-  //   CServerDistributionDescription serverDescription(globalDim, nbServer);
-  //   serverDescription.computeServerDistribution();
-
-  //   std::vector<std::vector<int> > serverIndexBegin = serverDescription.getServerIndexBegin();
-  //   std::vector<std::vector<int> > serverDimensionSizes = serverDescription.getServerDimensionSizes();
-
-  //   globalDimGrid.resize(globalDim.size());
-  //   for (int idx = 0; idx < globalDim.size(); ++idx) globalDimGrid(idx) = globalDim[idx];
-
-  //   CEventClient event(getType(),EVENT_ID_SERVER_ATTRIBUT);
-  //   if (contextClientTmp->isServerLeader())
-  //   {
-  //     std::list<CMessage> msgs;
-
-  //     const std::list<int>& ranks = contextClientTmp->getRanksServerLeader();
-  //     for (std::list<int>::const_iterator itRank = ranks.begin(), itRankEnd = ranks.end(); itRank != itRankEnd; ++itRank)
-  //     {
-  //       // Use const int to ensure CMessage holds a copy of the value instead of just a reference
-  //       const int begin = serverIndexBegin[*itRank][orderPositionInGrid];
-  //       const int ni    = serverDimensionSizes[*itRank][orderPositionInGrid];
-  //       const int end   = begin + ni - 1;
-
-  //       msgs.push_back(CMessage());
-  //       CMessage& msg = msgs.back();
-  //       msg << this->getId();
-  //       msg << ni << begin << end;
-  //       msg << global_zoom_begin.getValue() << global_zoom_n.getValue();
-  //       msg << isCompressible_;
-  //       msg << orderPositionInGrid;
-  //       msg << globalDimGrid;
-
-  //       event.push(*itRank,1,msg);
-  //     }
-  //     contextClientTmp->sendEvent(event);
-  //   }
-  //   else contextClientTmp->sendEvent(event);
-  // }
-
-  // void CAxis::recvServerAttribut(CEventServer& event)
-  // {
-  //   CBufferIn* buffer = event.subEvents.begin()->buffer;
-  //   string axisId;
-  //   *buffer >> axisId;
-  //   get(axisId)->recvServerAttribut(*buffer);
-
-  //   CContext* context = CContext::getCurrent();
-  //   if (context->hasClient && context->hasServer)
-  //   {
-  //     std::vector<int> globalDim(get(axisId)->globalDimGrid.numElements());
-  //     for (int idx = 0; idx < globalDim.size(); ++idx) globalDim[idx] = get(axisId)->globalDimGrid(idx);
-  //     get(axisId)->sendServerAttribut(globalDim, get(axisId)->orderPosInGrid, 
-  //                                     CServerDistributionDescription::BAND_DISTRIBUTION);
-  //   }
-  // }
-
-  // void CAxis::recvServerAttribut(CBufferIn& buffer)
-  // {
-  //   int ni_srv, begin_srv, end_srv, global_zoom_begin_tmp, global_zoom_n_tmp;
-
-  //   buffer >> ni_srv >> begin_srv >> end_srv;
-  //   buffer >> global_zoom_begin_tmp >> global_zoom_n_tmp;
-  //   buffer >> isCompressible_;
-  //   buffer >> orderPosInGrid;
-  //   buffer >> globalDimGrid;
-
-  //   global_zoom_begin = global_zoom_begin_tmp;
-  //   global_zoom_n  = global_zoom_n_tmp;
-  //   int global_zoom_end = global_zoom_begin + global_zoom_n - 1;
-
-  //   zoom_begin_srv = global_zoom_begin > begin_srv ? global_zoom_begin : begin_srv ;
-  //   zoom_end_srv   = global_zoom_end < end_srv ? global_zoom_end : end_srv ;
-  //   zoom_size_srv  = zoom_end_srv - zoom_begin_srv + 1;
-
-  //   if (zoom_size_srv<=0)
-  //   {
-  //     zoom_begin_srv = 0; zoom_end_srv = 0; zoom_size_srv = 0;
-  //   }
-
-  //   if (n_glo == n)
-  //   {
-  //     zoom_begin_srv = global_zoom_begin;
-  //     zoom_end_srv   = global_zoom_end; //zoom_end;
-  //     zoom_size_srv  = zoom_end_srv - zoom_begin_srv + 1;
-  //   }
-  //   if (hasValue)
-  //   {
-  //     value_srv.resize(zoom_size_srv);
-  //     if (hasBounds_)  bound_srv.resize(2,zoom_size_srv);
-  //   }
-  // }
+    if (doZoomByIndex_)
+    {
+      int nbZoomIndex = 0;
+      for (int idx = 0; idx < nbReceived; ++idx)
+      {
+        nbZoomIndex += vec_zoomInd[idx].numElements();
+      }
+
+      zoom_index.resize(nbZoomIndex);
+      nbZoomIndex = 0;      
+      for (int idx = 0; idx < nbReceived; ++idx)
+      {      
+        CArray<int,1>& tmp = vec_zoomInd[idx];
+        for (int i = 0; i < tmp.size(); ++i)
+        {
+          zoom_index(nbZoomIndex) = tmp(i);
+          ++nbZoomIndex;
+        }       
+      }
+    }
+
+
+    // {
+    //   CContextServer* server = CContext::getCurrent()->server;
+    //   count_write_index_ = zoom_index.numElements();      
+    //   MPI_Scan(&count_write_index_, &start_write_index_, 1, MPI_INT, MPI_SUM, server->intraComm);
+    //   global_write_size_ = start_write_index_;
+    //   start_write_index_ -= count_write_index_;
+    //   local_write_size_ = count_write_index_;      
+    // }
+  }
+
+  void CAxis::recvDistributionAttribute(CEventServer& event)
+  {
+    CBufferIn* buffer = event.subEvents.begin()->buffer;
+    string axisId;
+    *buffer >> axisId;
+    get(axisId)->recvDistributionAttribute(*buffer);
+  }
+
+  void CAxis::recvDistributionAttribute(CBufferIn& buffer)
+  {
+    int ni_srv, begin_srv, end_srv, global_zoom_begin_tmp, global_zoom_n_tmp;
+
+    buffer >> ni_srv >> begin_srv >> end_srv;
+    buffer >> global_zoom_begin_tmp >> global_zoom_n_tmp;
+    buffer >> isCompressible_;
+    buffer >> orderPosInGrid;
+    buffer >> globalDimGrid;
+
+    n.setValue(ni_srv);
+    begin.setValue(begin_srv);
+    global_zoom_begin = global_zoom_begin_tmp;
+    global_zoom_n  = global_zoom_n_tmp;
+    int global_zoom_end = global_zoom_begin + global_zoom_n - 1;
+
+    zoom_begin = global_zoom_begin > begin_srv ? global_zoom_begin : begin_srv ;
+    zoom_end_srv   = global_zoom_end < end_srv ? global_zoom_end : end_srv ;
+    zoom_n  = zoom_end_srv - zoom_begin_srv + 1;
+
+    if (zoom_n<=0)
+    {
+      zoom_begin = 0; zoom_end_srv = 0; zoom_n = 0;
+    }
+
+    if (n_glo == n)
+    {
+      zoom_begin = global_zoom_begin;
+      zoom_end_srv   = global_zoom_end; //zoom_end;
+      zoom_n     = zoom_end_srv - zoom_begin + 1;
+    }
+  }
+
 
   CTransformation<CAxis>* CAxis::addTransformation(ETranformationType transType, const StdString& id)
Index: XIOS/dev/dev_olga/src/node/axis.hpp
===================================================================
--- XIOS/dev/dev_olga/src/node/axis.hpp	(revision 1077)
+++ XIOS/dev/dev_olga/src/node/axis.hpp	(revision 1099)
@@ -45,5 +45,5 @@
          enum EEventId
          {
-           EVENT_ID_SERVER_ATTRIBUT,
+           EVENT_ID_DISTRIBUTION_ATTRIBUTE,
            EVENT_ID_INDEX,
            EVENT_ID_DISTRIBUTED_VALUE,
@@ -108,9 +108,7 @@
          static ENodeType GetType(void);
 
-         // void sendServerAttribut(const std::vector<int>& globalDim, int orderPositionInGrid,
-         //                         CServerDistributionDescription::ServerDistributionType distType);
          static bool dispatchEvent(CEventServer& event);
-         static void recvServerAttribut(CEventServer& event);
-         // void recvServerAttribut(CBufferIn& buffer) ;
+         static void recvDistributionAttribute(CEventServer& event);
+         void recvDistributionAttribute(CBufferIn& buffer) ;
          void checkAttributesOnClient();
          void checkAttributesOnClientAfterTransformation(const std::vector<int>& globalDim, int orderPositionInGrid,
@@ -142,5 +140,8 @@
          void checkZoom();
          void checkBounds();         
-         void sendAttributes();
+         void sendAttributes(const std::vector<int>& globalDim, int orderPositionInGrid,
+                             CServerDistributionDescription::ServerDistributionType distType);
+         void sendDistributionAttribute(const std::vector<int>& globalDim, int orderPositionInGrid,
+                                        CServerDistributionDescription::ServerDistributionType distType);
          void computeConnectedServer(const std::vector<int>& globalDim, int orderPositionInGrid,
                                      CServerDistributionDescription::ServerDistributionType distType);
@@ -180,4 +181,6 @@
          int global_write_size_;
 
+         bool doZoomByIndex_;
+
        private:
          static bool initializeTransformationMap(std::map<StdString, ETranformationType>& m);
Index: XIOS/dev/dev_olga/src/node/context.cpp
===================================================================
--- XIOS/dev/dev_olga/src/node/context.cpp	(revision 1077)
+++ XIOS/dev/dev_olga/src/node/context.cpp	(revision 1099)
@@ -300,4 +300,5 @@
      std::map<int, StdSize> dataBufferSize = getDataBufferSize(maxEventSize);
 
+
      std::map<int, StdSize>::iterator it, ite = dataBufferSize.end();
      for (it = dataBufferSize.begin(); it != ite; ++it)
@@ -475,9 +476,15 @@
      if (allProcessed) return;
      
-     if (hasClient)
-     {
+     // if (hasClient)
+     // {
        // After xml is parsed, there are some more works with post processing
        postProcessing();
-     }
+
+       // Check grid and calculate its distribution
+       checkGridEnabledFields();
+
+     //}
+
+
 
      setClientServerBuffer();
@@ -502,9 +509,12 @@
 
        // After that, send all grid (if any)
-       sendRefGrid();
+       sendRefGrid();       
 
        // We have a xml tree on the server side and now, it should be also processed
        sendPostProcessing();
-     }
+
+       sendGridEnabledFields();       
+     }
+
      allProcessed = true;
    }
@@ -523,5 +533,8 @@
        {
          CMessage msg;
-         msg<<this->getIdServer();
+         if (hasServer)
+           msg<<this->getIdServer(i);
+         else
+           msg<<this->getIdServer();
          const std::list<int>& ranks = contextClientTmp->getRanksServerLeader();
          for (std::list<int>::const_iterator itRank = ranks.begin(), itRankEnd = ranks.end(); itRank != itRankEnd; ++itRank)
@@ -538,10 +551,9 @@
       string id;
       *buffer>>id;
-      // get(id)->recvPostProcessingGlobalAttributes(*buffer);
+      get(id)->recvPostProcessingGlobalAttributes(*buffer);
    }
 
    void CContext::recvPostProcessingGlobalAttributes(CBufferIn& buffer)
-   {
-      // CCalendarWrapper::get(CCalendarWrapper::GetDefName())->createCalendar();
+   {      
       postProcessingGlobalAttributes();
    }
@@ -570,6 +582,8 @@
     }
 
-    // if (hasClient) this->solveAllRefOfEnabledFields(true);
-    this->processGridEnabledFields();
+    // if (hasClient) this->solveAllRefOfEnabledFields(true);    
+    checkGridEnabledFields();
+    // sendGridEnabledFields();
+
     if (hasClient) this->sendProcessingGridOfEnabledFields();
     if (hasClient) this->sendCloseDefinition();
@@ -617,11 +631,19 @@
    }
 
-   void CContext::processGridEnabledFields()
+   void CContext::sendGridEnabledFields()
    {
      int size = this->enabledFiles.size();
      for (int i = 0; i < size; ++i)
-     {
-       this->enabledFiles[i]->checkGridOfEnabledFields();
+     {       
        this->enabledFiles[i]->sendGridOfEnabledFields();
+     }
+   }
+
+   void CContext::checkGridEnabledFields()
+   {
+     int size = this->enabledFiles.size();
+     for (int i = 0; i < size; ++i)
+     {
+       this->enabledFiles[i]->checkGridOfEnabledFields();       
      }
    }
@@ -993,5 +1015,8 @@
        {
          CMessage msg;
-         msg<<this->getIdServer();
+         if (hasServer)
+           msg<<this->getIdServer(i);
+         else
+           msg<<this->getIdServer();
          const std::list<int>& ranks = contextClientTmp->getRanksServerLeader();
          for (std::list<int>::const_iterator itRank = ranks.begin(), itRankEnd = ranks.end(); itRank != itRankEnd; ++itRank)
@@ -1009,5 +1034,5 @@
       string id;
       *buffer>>id;
-      // get(id)->processGridEnabledFields();
+      //get(id)->solveOnlyRefOfEnabledFields(false);
    }
 
@@ -1140,8 +1165,11 @@
 
       // Only search and rebuild all reference objects of enable fields, don't transform
-      if (hasClient) this->solveOnlyRefOfEnabledFields(false);
-
-      // Search and rebuild all reference object of enabled fields
-      // if (hasClient) this->solveAllRefOfEnabledFields(false);
+      this->solveOnlyRefOfEnabledFields(false);
+
+      // Search and rebuild all reference object of enabled fields, and transform
+      this->solveAllEnabledFields();
+
+      // // Check grid and calculate its distribution
+      // if (hasClient) checkGridEnabledFields();
 
       // Find all fields with read access from the public API
@@ -1216,17 +1244,20 @@
          for (size_t j = 0; j < numEnabledFields; ++j)
          {
-           const std::map<int, StdSize> mapSize = enabledFields[j]->getGridDataBufferSize();
-           std::map<int, StdSize>::const_iterator it = mapSize.begin(), itE = mapSize.end();
-           for (; it != itE; ++it)
+           const std::vector<std::map<int, StdSize> > mapSize = enabledFields[j]->getGridDataBufferSize();
+           for (size_t c = 0; c < mapSize.size(); ++c)
            {
-             // If dataSize[it->first] does not exist, it will be zero-initialized
-             // so we can use it safely without checking for its existance
-             if (CXios::isOptPerformance)
-               dataSize[it->first] += it->second;
-             else if (dataSize[it->first] < it->second)
-               dataSize[it->first] = it->second;
-
-             if (maxEventSize[it->first] < it->second)
-               maxEventSize[it->first] = it->second;
+             std::map<int, StdSize>::const_iterator it = mapSize[c].begin(), itE = mapSize[c].end();
+             for (; it != itE; ++it)
+             {
+               // If dataSize[it->first] does not exist, it will be zero-initialized
+               // so we can use it safely without checking for its existance
+               if (CXios::isOptPerformance)
+                 dataSize[it->first] += it->second;
+               else if (dataSize[it->first] < it->second)
+                 dataSize[it->first] = it->second;
+
+               if (maxEventSize[it->first] < it->second)
+                 maxEventSize[it->first] = it->second;
+             }
            }
          }
Index: XIOS/dev/dev_olga/src/node/context.hpp
===================================================================
--- XIOS/dev/dev_olga/src/node/context.hpp	(revision 1077)
+++ XIOS/dev/dev_olga/src/node/context.hpp	(revision 1099)
@@ -126,5 +126,6 @@
 
          void solveAllEnabledFields();
-         void processGridEnabledFields();
+         void checkGridEnabledFields();
+         void sendGridEnabledFields();
 
          std::map<int, StdSize> getAttributesBufferSize(std::map<int, StdSize>& maxEventSize);
